
// --------------------------------------------------------
// -------------------- color -----------------------------
// --------------------------------------------------------

/* Color is loaded from an external file to avoid unnecesary color calculations */

PImage stripeColor;
// -----------------------------------------------------
void loadColors(){
  // We load the image(s)
  stripeColor = loadImage("data/color/"+stripeName+".png");
}

// ----------------------------------------------------
// We return the color based on a number we receive from 1 to 0
// We receive event data as  "Boston" or "Osama"
color getColor(float pos){
  
  // Safety check, just in case #realityHitsYourHardBro
  if(pos > 1) pos = 1;
  if(pos < 0) pos = 0; 
  
  // WE create a local stripe, depending on the event to load
  PImage stripeLocal =  stripeColor;
  
   // We map the value
  float deseo = map( pos, 0, 1, 1, stripeLocal.width-2 );
  
  return stripeLocal.get( floor(deseo), floor(stripeLocal.height/2) );

}
