
// ---------------------------------------------------------------
// -------------------- data parsing -----------------------------
// ---------------------------------------------------------------

Table tabla; 
// 
int [][] datos;// All data will be hosted here
int [][] datosR; // Renglones
int [][]datosOriginales; // The untouchableData
String [] headers; // All the headers will be located here.

int [] columna3;
int [] columna3Original;
int [] columna3Columnas;

//
// -----------------------------------------------------------------------------------------------------------------
// Esta función va a encargarse de todos los datos a cargar --------------------------------------------------------
//
int[][] dataParsing(String tableName) {
  if (feedback) println(">> LOADING DATA: ON! ---> "+tableName);

  // We load the table, alright!
  tabla = new Table();
  tabla = loadTable("data/databases/autobiographyquery.csv");

  // We set total rows and columnes (ignoring the first line) since all databases are the same, it really won't matter
  totalRows = tabla.getRowCount();
  totalCols = tabla.getColumnCount();

  // We load the headers (there will be only one type of headers). This is useful, to load the titles afterwards
  String [] headersT = new String[1];
  headersT = loadStrings("data/databases/autobiographyquery.csv");
  if (feedback) println(">> Temporary headers: "+headersT[0]); // Everything in this position is comma separated

  // We create the final headers array, Some feedback never hurts does it?
  headers = split( headersT[0], "," );
  if (feedback) println(">> 1st header: "+headers[0]);
  if (feedback) println(">> 2nd header: "+headers[1]);
  if (feedback) println(">> Last header: "+headers[headers.length-1]);


  // We set the total elements
  totales = (totalRows-1)*totalCols; // -1 por los headers, abusado!
  if (feedback) println(">> Elementos totales: "+totales);

  // We verify the data
  if (feedback) println(">> Tenemos "+totalRows+" rows.");
  if (feedback) println(">> Tenemos "+totalCols+" columns.");

  // We'll arrange everything into the dataMatrix
  //if(feedback) println(">> TABLE CONTENTS:");

  // We create the data Array to put everything inside
  int [][] dataMatrix = new int[totalRows][totalCols];

  // temporary variables for highest number
  float numeroMayor = 0;
  float numeroMenor = 500000;

  // We start sorting everythings
  for (int i = 0; i < totalRows; i++) {
    for (int j = 0; j < totalCols; j++) {

      int dato = tabla.getInt( i, j );
      // We place the values
      dataMatrix[i][j] = dato;

      // We verify highest and lowest number
      if ( numeroMenor >  dato && i > 0 && j == 3 ) numeroMenor = dato;
      if ( numeroMayor <  dato && i > 0 && j == 3 ) numeroMayor = dato;
      // Temporary output
      // if (feedback) println(">> R:"+i+" |C:"+j+" = "+ dato);
    }
  }

  // We set the global numbers for high and low value
  if (numeroMayor > noMayor) noMayor = numeroMayor;
  if (numeroMenor < noMenor) noMenor = numeroMenor;

  if (feedback && tableName == "AUTOBIOS") println(">> Highest / Low found value Boston: "+noMayor+" / "+noMenor);
  if (feedback) println(">> Global - Highest found value: "+numeroMayor);
  if (feedback) println(">> Global - Lowest found value: "+numeroMenor);

  //Note to self: all of the data will start in 0 position, no, can't remember to be honest.

  // WE will copy all data into the Array columna 3
  int [] columna3T = new int[ totalRows ];
  columna3Original = new int[ totalRows ];
  columna3 = new int[ totalRows ];
  columna3Columnas = new int[ totalRows ];
  for (int i = 1; i < totalRows; i++) {
    columna3T[i] = dataMatrix[i][3];
    columna3Columnas[i] = 0;
  }
  arrayCopy(columna3T, columna3Original);
  arrayCopy(columna3T, columna3);

  // We return the Array, finally
  return dataMatrix;
}

